#ifdef __cplusplus 
extern "C" { 
#endif 

#ifndef __CHARTFX20__

// Routines Provided
HWND WINAPI chart_Create(long, long, HWND,int ,int ,int ,int ,int ,int ,UINT ,DWORD);
long WINAPI chart_Send(HWND ,UINT ,WPARAM ,LPARAM);
long WINAPI chart_OpenData(HWND, UINT, DWORD);
BOOL WINAPI chart_CloseData(HWND ,UINT);
long WINAPI chart_SetValue(HWND, int, int, double);
long WINAPI chart_SetIniValue(HWND ,int, int, double);
long WINAPI chart_SetXvalue(HWND , int ,int ,double);
long WINAPI chart_SetConst(HWND, int, double);
long WINAPI chart_SetColor(HWND, int, DWORD, BOOL);
void WINAPI chart_SetAdm(HWND, int, double);
long WINAPI chart_SetStripe(HWND, int, double, double, DWORD);
long WINAPI chart_SetStatusItem(HWND, int, BOOL, UINT, BOOL, int, int, int, DWORD);
double WINAPI chart_Get(HWND, long, UINT);
void WINAPI chart_Get2(HWND, long, UINT, double far *);
void WINAPI chart_Paint(HWND, HDC, int, int, int, int, UINT, LPPAINTSTRUCT);
long WINAPI chart_OpenDataEx(HWND ,UINT , int, int);
double WINAPI chart_GetAdm(HWND, int);
void WINAPI chart_GetAdm2(HWND, int, double far *);

// Notification Messages
#define CN_LBUTTONDBLCLK	0x0000
#define CN_RBUTTONDOWN		0x0001
#define CN_CHANGEVALUE		0x0002
#define CN_CHANGESTRING		0x0003
#define CN_CHANGECOLOR		0x0004
#define CN_DESTROY			0x0005		// You will not receive this event if the chart is a child (i.e. VBX)
#define CN_POSTDESTROY		CN_DESTROY	// Obsolete
#define CN_READFILE			0x0006
#define CN_CHANGEPALETTE	0x0007
#define CN_CHANGEFONT		0x0008
#define CN_READTEMPLATE		0x0009
#define CN_CHANGEPATTERN	0x000A
#define CN_CHANGEPATTPAL	0x000B
#define CN_MENU				0x000C
#define CN_CHANGETYPE		0x000D
#define CN_SCROLL			0x000E		
#define CN_GETLEGEND		0x000F		
#define CN_INTERNALCOMMAND	0x0010
#define CN_USERCOMMAND		0x0011		// Using the DLL you will not receive this event
#define CN_SHOWTOOLBAR		0x0012
#define CN_PREPAINT			0x0013
#define CN_POSTPAINT		0x0014
#define CN_PAINTMARKER		0x0015
#define CN_LBUTTONDOWN		0x0016
#define CN_LBUTTONUP		0x0017
#define CN_RBUTTONUP		0x0018
#define CN_RBUTTONDBLCLK	0x0019
#define CN_MOUSEMOVE		0x001A

#define CN_KILLFOCUS		0xFFFE
#define CN_SETFOCUS			0xFFFF
//

// Notification Codes
enum { CCC_SERIE, CCC_SERIEBK, CCC_ONE, CCC_ONEBK, CCC_BARHORZ, CCC_BKGND, CCC_2DBK, CCC_3DBK };
enum { CCS_LEGEND, CCS_SERLEGEND };
enum { CCP_SERIE, CCP_ONE };

// Constants

// Gallery Types
enum { LINE = 1, BAR, SPLINE, MARK, PIE, AREA, PARETO, SCATTER, HILOW, SURFACE, POLAR, CUBE, DOUGHNUT};

// Chart Types 
#define CT_3D				0x00000100L
#define CT_HORZ  			0x00000200L
#define CT_TOOL				0x00000400L
#define CT_PALETTE			0x00000800L
#define CT_LEGEND			0x00001000L
#define CT_TOGETHER			0x00002000L			// Obsolete Use CM_MARKERVOLUME
#define CT_POINTS			0x00004000L
#define CT_SHOWZERO			0x00008000L
#define CT_EACHBAR			0x00010000L
#define CT_CLUSTER			0x00020000L
#define CT_SHOWDATA			0x00040000L
#define CT_DLGGRAY			0x00080000L
#define CT_PATTERN			0x00100000L
#define CT_SHOWVALUES		0x00200000L
#define CT_MENU				0x00400000L
#define CT_SHOWLINES		0x00800000L		
#define CT_SCATTERLINE		CT_SHOWLINES
#define CT_COLORLINE		0x01000000L
#define CT_NOAREALINE		0x02000000L
#define CT_HILOWSTD			CT_NOAREALINE
#define CT_NOBORDERS		0x04000000L
#define CT_PIEVALUES		0x08000000L
#define CT_TRACKMOUSE		0x10000000L
#define CT_EVENSPACING		0x20000000L
#define CT_SERLEGEND		0x40000000L
#define CT_PAINTMARKER		0x80000000L

// Extended types
#define CTE_STEPLINES		0x00000001L
#define CTE_SMOOTH			0x00000002L
#define CTE_SQUAREPIE		0x00000004L 
#define CTE_NOLEGINVALIDATE	0x00000008L
#define CTE_ACTMINMAX		0x00000010L
#define CTE_NOTITLESHADOW	0x00000020L

// Extended Types

#define CS_CHLINE			0x00000001L
#define CS_CHBAR			0x00000002L
#define CS_CHSPLINE			0x00000004L
#define CS_CHMARK			0x00000008L
#define CS_CHPIE			0x00000010L
#define CS_CHAREA			0x00000020L
#define CS_CHPARETO			0x00000040L
#define CS_CHSCATTER		0x00000080L
#define CS_CHHILOW			0x00000100L
#define CS_MULTITYPE		0x00000800L
#define CS_CHDEFAULT		0x00000FFFL
#define CS_MINMAX			0x00001000L
#define CS_3D				0x00002000L
#define CS_HORZ				0x00004000L
#define CS_TOGETHER			0x00008000L
#define CS_SHOWPOINT		0x00010000L
#define CS_SCALE			0x00020000L
#define CS_TITLES			0x00040000L
#define CS_FONTS			0x00080000L
#define CS_EDITABLE			0x00100000L
#define CS_FILEEXPORT		0x00200000L
#define CS_FILEIMPORT		0x00400000L
#define CS_SCROLLABLE		0x00800000L
#define CS_PRINTABLE		0x01000000L
#define CS_3DVIEW			0x02000000L
#define CS_GRID				0x04000000L
#define CS_RESIZEABLE		0x08000000L
#define CS_TEMPLATE			0x10000000L
#define CS_COPY				0x20000000L
#define CS_CLOSEABLE		0x40000000L
#define CS_LOGSCALE			0x80000000L
#define CS_ALL				0xFFFFFFFFL

// chart_Send Constants

// Messages
#define CM_SETTYPE				0x0001
#define CM_SETSTYLE				0x0002
#define CM_SETGAP				0x0003
#define CM_SETDECIMALS			0x0004
#define CM_SETPOINTTYPE			0x0005
#define CM_SETSCHEME			0x0006
#define CM_SETSTACKED			0x0007
#define CM_SETGRID				0x0008
#define CM_SETWALLWIDTH			0x0009
#define CM_SETCOLOR				0x000A
#define CM_SETBKCOLOR			0x000B
#define CM_SETPATTERN			0x000C
#define CM_SETBARHORZGAP		0x000D
#define CM_SET3DVIEW			0x000E
#define CM_SETPIXFACTOR			0x000F
#define CM_SETLINEWIDTH			0x0010
#define CM_SETLINESTYLE			0x0011
#define CM_SETLINECOLOR			0x0012
#define CM_SETFIXEDWIDTH		0x0013
#define CM_SETFIXEDSTYLE		0x0014
#define CM_SETFIXEDCOLOR		0x0015
#define CM_SETFIXEDGAP			0x0016
#define CM_SETDBLCLK			0x0017
#define CM_SETRIGCLK			0x0018
#define CM_SETRGBBARHORZ		0x0019
#define CM_SETRGBBK				0x001A
#define CM_SETRGB2DBK			0x001B
#define CM_SETRGB3DBK			0x001C
#define CM_SETFONT				0x001D
#define CM_SETSTATUS			0x001E
#define CM_SHOWSTATUS			0x001F
#define CM_SETLANGUAGE			0x0020
#define CM_SETTITLE				0x0021
#define CM_GETTITLE				0x0022
#define CM_SETHTEXT				0x0023
#define CM_GETHTEXT				0x0024
#define CM_SETLEGEND			0x0025
#define CM_SETSERLEG			0x0026
#define CM_SETKEYLEG			0x0027
#define CM_SETFIXLEG			0x0028
#define CM_SETYLEG				0x0029
#define CM_SETKEYSER			0x002A
#define CM_GETKEYSER			0x002B
#define CM_GETLEGEND			0x002C
#define CM_GETSERLEG			0x002D
#define CM_GETKEYLEG			0x002E
#define CM_GETFIXLEG			0x002F
#define CM_GETYLEG				0x0030
#define CM_SETHWNDMSG			0x0031
#define CM_SETID				0x0032
#define CM_SETSTATUSTEXT		0x0033
#define CM_GETLAST				0x0034
#define CM_EXPORTFILE			0x0035
#define CM_IMPORTFILE			0x0036
#define CM_NEW                  0x0037
#define CM_WRITETEMPLATE		0x0038
#define CM_READTEMPLATE			0x0039
#define CM_GETSTATUS			0x003A
#define CM_SETRGBFONT			0x003B
#define CM_GETEDIT				0x003C
#define CM_COPYDATA				0x003D
#define CM_COPYBITMAP			0x003E
#define CM_PRINT				0x003F
#define CM_SETHFONT				0x0040
#define CM_SETFIXEDBKCOLOR		0x0041
#define CM_GETLASTEXTRA			0x0042
#define CM_SETLINEBKCOLOR		0x0043
#define CM_SETTOOL				0x0044
#define CM_GETSERIEPOINT		0x0045
#define CM_SETVERTGRIDGAP		0x0046
#define CM_SETXLEGTYPE			0x0047			// Obsolete (Keeped for compatibility)
#define CM_LEGSTYLE				0x0047
#define CM_SETCONSTTYPE			0x0048
#define CM_SETITEMWIDTH			0x0049
#define CM_SETITEMCOLOR			0x004A
#define CM_SETITEMSTYLE			0x004B
#define CM_SHOWDIALOG			0x004C
#define CM_SETLEGENDWIDTH		0x004D			// Obsolete (Keeped for compatibility)
#define CM_TOOLSIZE				0x004D
#define CM_SCROLL				0x004E
#define CM_BARBITMAP			0x004F
#define CM_MARKERSIZE			0x0050
#define CM_MARKERVOLUME			0x0051
#define CM_DEPTH				0x0052
#define CM_LIGHT				0x0053
#define CM_SHAPE				0x0054
#define CM_MULTITYPE			0x0055
#define CM_MULTISHAPE			0x0056
#define CM_GALLERYTOOL			0x0057
#define CM_CLEARLEGEND			0x0058
#define CM_MAXVALUES			0x0059
#define CM_REALTIMESTYLE		0x005A
#define CM_EXPORT				0x005B
#define CM_TBBITMAP				0x005C
#define CM_TBITEMID				0x005D
#define CM_TBITEMSTYLE			0x005E			
#define CM_ENABLETBITEM			0x005F
#define CM_MULTIYAXIS			0x0060
#define CM_TOOLSTYLE			0x0061
#define CM_ZOOM					0x0062
#define CM_SETITEMBKCOLOR		0x0063
#define CM_IMPORT				0x0064
#define CM_SEPARATESLICE		0x0065
#define CM_GETPAINTINFO			0x0066
#define CM_TOOLPOS				0x0067
#define CM_MULTIPOINT			0x0068
#define CM_EXTTYPE				0x0069
#define CM_EXTSTYLE				0x006A
#define CM_MOUSECAPTURE			0x006B
#define CM_MULTILINESTYLE		0x006C
#define CM_CURRENTAXIS			0x006D

// CM_SETSTYLE, CM_SETTYPE Constants
enum { CHART_ADD, CHART_SET, CHART_REMOVE };

// CM_SETSTACKED Constants
enum { CHART_NOSTACKED, CHART_STACKED, CHART_STACKED100 };

// CM_SETGRID Constants
enum { CHART_NOGRID, CHART_HORZGRID, CHART_VERTGRID, CHART_BOTHGRID, CHART_GRIDY2};

// CM_SEPOINTTYPE Constants
enum { CHART_NONEMK, CHART_RECTMK, CHART_CIRCLEMK, CHART_TRIANGLEMK, CHART_MARBLEMK, CHART_CUBEMK, CHART_MANYMK };

// CM_SETTITLE Constants
enum { CHART_LEFTTIT, CHART_RIGHTTIT, CHART_TOPTIT, CHART_BOTTOMTIT };

// CM_SETFONT Constants
enum { CHART_LEFTFT, CHART_RIGHTFT, CHART_TOPFT, CHART_BOTTOMFT, CHART_XLEGFT, CHART_YLEGFT, CHART_FIXEDFT, CHART_LEGENDFT, CHART_VALUESFT, CHART_POINTFT };

// CM_SETDBLCLK, CM_SETRIGCLK Constants
enum { CHART_BALLOONCLK, CHART_DIALOGCLK, CHART_NONECLK, CHART_MENUCLK };

// CM_SETGAP Constants
enum { CHART_LEFTGAP, CHART_RIGHTGAP, CHART_TOPGAP, CHART_BOTTOMGAP, CHART_ALLGAP };

// Colors    
#define CHART_TRANSPARENT 0x80000000L

enum { CHART_WHITE=1, CHART_BLACK, CHART_LTGRAY, CHART_DKGRAY, CHART_RED, CHART_DKRED, CHART_BLUE,
	   CHART_DKBLUE, CHART_GREEN, CHART_DKGREEN, CHART_CYAN, CHART_DKCYAN, CHART_YELLOW,
	   CHART_DKYELLOW, CHART_VIOLET, CHART_DKVIOLET };

// CM_SETITEMSTYLE, CM_SETLINESTYLE, CM_SETFIXEDSTYLE Constants
enum { CHART_SOLID, CHART_DASH, CHART_DOT, CHART_DASHDOT, CHART_DASHDOTDOT };

// CM_SETSCHEME Constants
enum { CHART_CSSOLID, CHART_CSBWPATTERN, CHART_CSPATTERN };

// chart_SetColor Types
enum { CHART_FGROUND, CHART_BGROUND };

// chart_Get Constants
enum { CHART_GVALUES, CHART_GINIVALUES, CHART_GXVALUES };

// CM_SETLEGSTYLE Constants
#define CL_NOTCLIPPED		0x0001
#define CL_NOTCHANGECOLOR	0x0002
#define CL_HIDE				0x0004		// Obsolete (use CL_HIDEXLEG)
#define CL_HIDEXLEG			0x0004
#define CL_FORCESERLEG		0x0008
#define CL_GETLEGEND		0x0010
#define CL_HIDEYLEG			0x0020
#define CL_2LEVELS          0x0040
#define CL_VERTXLEG         0x0080
#define CL_SHOWZLEG			0x0100 

// CM_SETCONSTTYPE Constants
#define CC_HIDETEXT			0x0001  
#define CC_HIDE 			0x0002  

// CM_SETITEM* {STYLE | COLOR | BKCOLOR | WIDTH}
enum { CI_HORZGRID, CI_VERTGRID, CI_2DLINE, CI_FIXED, CI_LOOPPOS, CI_HORZGRID2 };

#define CHART_PS_TRANSPARENT	0x4000

// CM_SETDECIMALS Constants
enum { CD_ALL, CD_VALUES, CD_YLEG, CD_XLEG, CD_YLEG2 };

// CM_GETSTATUS Constants
#define CHART_GSVALUES		0x00000001L
#define CHART_GSLEGENDS		0x00000002L
#define CHART_GSCOLORS		0x00000004L
#define CHART_GSPATTERNS	0x00000008L
#define CHART_GSPALETTE		0x00000010L
#define CHART_GSPATTPAL		0x00000020L
#define CHART_GSREADTEMP	0x00000040L
#define CHART_GSREADFILE	0x00000080L
#define CHART_GSGALLERY		0x00000100L
#define CHART_GSOPTIONS		0x00000200L

// CM_SETTOOL Constants
#define CST_IMPORT			0x00000001L
#define CST_EXPORT			0x00000002L
#define CST_FILE			(CST_IMPORT | CST_EXPORT)
#define CST_COPYBITMAP		0x00000004L
#define CST_COPYDATA		0x00000008L
#define CST_COPY			(CST_COPYBITMAP | CST_COPYDATA)
#define CST_PRINT			0x00000010L
#define CST_FILEEDIT		(CST_FILE | CST_COPY | CST_PRINT)
#define CST_SPACE1			0x00000020L
#define CST_GALLERY			0x00000040L
#define CST_SPACECOMBO		0x00000080L
#define CST_COLOR			0x00000100L
#define CST_SPACE2			0x00000200L
#define CST_3D				0x00000400L
#define CST_ROTATE			0x00000800L
#define CST_CLUSTER			0x00001000L
#define CST_ZOOM			0x00002000L
#define CST_VIEW			(CST_3D | CST_ROTATE | CST_CLUSTER | CST_ZOOM)
#define CST_SPACE3			0x00004000L
#define CST_LEGEND			0x00008000L
#define CST_SERLEGEND		0x00010000L
#define CST_VGRID			0x00020000L
#define CST_HGRID			0x00040000L
#define CST_LEGGRID			(CST_LEGEND | CST_SERLEGEND | CST_VGRID | CST_HGRID)
#define CST_SPACE4			0x00080000L
#define CST_TITLES			0x00100000L
#define CST_FONTS			0x00200000L
#define CST_TOOLS			0x00400000L
#define CST_OPTIONS			0x00800000L
#define CST_OTHER			(CST_TITLES | CST_FONTS | CST_TOOLS | CST_OPTIONS)

// CM_GALLERYTOOL Constants
#define CSG_LINE			0x00000001L
#define CSG_BAR				0x00000002L
#define CSG_SPLINE			0x00000004L
#define CSG_MARK			0x00000008L
#define CSG_PIE				0x00000010L
#define CSG_AREA			0x00000020L
#define CSG_PARETO			0x00000040L
#define CSG_SCATTER			0x00000080L
#define CSG_HILOW			0x00000100L
#define CSG_SURFACE			0x00000200L
#define CSG_POLAR			0x00000400L
#define CSG_CUBE			0x00000800L
#define CSG_DOUGHNUT		0x00001000L
#define CSG_BARHORZ			0x00002000L
#define CSG_ALL				0xFFFFFFFFL
			
// Fonts Constants
#define CF_BOLD				0x00000100L
#define CF_ITALIC			0x00000200L
#define CF_UNDERLINE		0x00000400L
#define CF_STRIKEOUT		0x00000800L
#define CF_FDONTCARE		0x00000000L
#define CF_FROMAN			0x00001000L
#define CF_FSWISS			0x00002000L
#define CF_FMODERN			0x00003000L
#define CF_FSCRIPT			0x00004000L
#define CF_FDECORATIVE		0x00005000L
#define CF_ARIAL			0x00000000L
#define CF_COURIER			0x00010000L
#define CF_COURIERNEW		0x00020000L
#define CF_HELVETICA		0x00030000L
#define CF_MODERN			0x00040000L
#define CF_ROMAN			0x00050000L
#define CF_SCRIPT			0x00060000L
#define CF_SYMBOL			0x00070000L
#define CF_TIMES			0x00080000L
#define CF_TIMESNEWR		0x00090000L
#define CF_WINGDINGS		0x000A0000L

// chart_OpenData Constants
#define COD_VALUES				1
#define COD_CONSTANTS			2
#define COD_COLORS				3
#define COD_STRIPES				4
#define COD_INIVALUES			5
#define COD_XVALUES				6
#define COD_STATUSITEMS			7

// OpenData and CloseData Actions
#define COD_SCROLLLEGEND		0x4000
#define COD_NOINVALIDATE		0x2000
#define COD_SMOOTH				0x1000
#define COD_REMOVE				0x0800
#define COD_ADDPOINTS			0x0400
#define COD_REALTIMESCROLL		0x0300		// INCLUDES COD_REALTIME
#define COD_REALTIME			0x0100
#define COD_RESETMINMAX			0x0080

#define COD_UNKNOWN				0xffff
#define COD_UNCHANGE			0

#define CHART_HIDDEN 3.402823466e+38F		// Same as FLT_MAX
					 
// chart_SetAdm,chart_GetAdm Constants
enum { CSA_MIN, CSA_MAX, CSA_GAP, CSA_SCALE, CSA_YLEGGAP, CSA_PIXXVALUE, CSA_XMIN, CSA_XMAX, CSA_XGAP, CSA_LOGBASE, 
	   CSA_MIN2, CSA_MAX2, CSA_GAP2, CSA_SCALE2, CSA_XSCALE, CSA_LOGBASE2, CSA_LOGBASEX }; 

#define CHART_LOGN 0

// chart_OpenData - chart_SetValue, ... return values
#define CR_OUTRANGE				-1
#define CR_NOOPEN				-2
#define CR_FAIL					-3
#define CR_INVALID				-4
#define CR_BADCODE				-5
#define CR_SUCCESS				0
#define CR_NEW					1
#define CR_KEEPALL				2
#define CR_LOSTLAST				3

// StatusBar Structure
typedef struct tagSTITEM {
	LPSTR sText;				// NULL -> no Text 
	UINT wIdm;
	BOOL bFrame;
	int nWidth;					// Width (pix)
	int nMin;					// Minimum width
	int nDesp;					// offset
	DWORD dwStyle;
} CHART_STITEM;

// 3D point
typedef struct {
			int x;
			int y;
			int z;
		} POINT3D;

typedef POINT3D far *LPPOINT3D;

// HILOW Constants

// Hi-Low-Close
enum { HLC_LOW, HLC_CLOSE, HLC_HIGH };
// Open-Hi-Low-Close
enum { OHLC_LOW, OHLC_OPEN, OHLC_CLOSE, OHLC_HIGH };

// CM_CLEARLEGEND values
enum { CHART_LEGEND, CHART_SERLEG, CHART_KEYLEG, CHART_KEYSER, CHART_FIXLEG, CHART_YLEG };

// CM_REALTIMESTYLE values
#define CRT_LOOPPOS			0x0001
#define CRT_NOWAITARROW		0x0002

// CM_EXPORT,CM_IMPORT values
enum { CHART_DATA, CHART_BITMAP, CHART_METAFILE, CHART_CFXFILE, CHART_CFXTEMPLATE,
	   CHART_INTERNALFILE, CHART_INTERNALTEMPLATE };

// chart_Paint Modes
#define CPAINT_BKGND		0x0002
#define CPAINT_PRINT		0x0001
                                 

// CM_TOOLSTYLE & CM_TOOLSIZE values
enum { CTOOL_LEGEND, CTOOL_SERLEGEND, CTOOL_TB};
#define CTOOL_OPTIONS		0x2000
#define CTOOL_MOVE			0x4000

// CM_TBBUTTONSTYLE values
#define CTBS_BUTTON			0x0001		// this entry is button
#define CTBS_SEPARATOR		0x0002		// this entry is a separator
#define CTBS_MENU			0x0004		// Displays a menu (ID = menu)
#define CTBS_ICONCOMBO		0x0008		// internal combo (Gallery & Color)
#define CTBS_HWND			0x0088		// External Window 	(ID = handle)
#define CTBS_DESTROY		0x0010		// Destroy External Window when Destroyed
#define CTBS_REPEAT			0x0800		// AutoRepeat button
#define CTBS_GROUP			0x1000		// Belongs to the current group
#define CTBS_2STATE			0x2000		// Two State Button
#define CTBS_GROUP2STATE	0x3000		// Two State Button that belongs to the current group
#define CTBS_HEAD			0x4000		// First Button of a group (New Group)

// Styles for tools CM_TOOLSTYLE
#define CTS_HIDEFOCUS		0x00008000	// Tool bar disappear when not active
#define CTS_WHITELINE		0x00010000	// Draw White Line (Shadow)
#define CTS_DELIMITER		0x00020000	// Draw Delimiter/Border when Child
#define CTS_SIZEABLE		0x00040000	// Sizeable when child
#define CTS_HORZLAYER		0x00080000	// Layerable when Horizontal
#define CTS_VERTLAYER		0x00100000	// Layerable when Vertical
#define CTS_SIZELAYER		0x00200000  // Sizeable when Layered
#define CTS_DBLCLKS			0x00400000	// Accept DBlClks (To Dock-Undock)
#define CTS_DOCKABLE		0x00800000	// Dockable
#define CTS_SPLITTER		0x01000000	// Draw Splitter
#define CTS_3DFRAME			0x02000000	// Draw 3D Frame
#define CTS_BORDERLAYER		0x04000000	// Draw LayerBorder Always
#define CTS_BORDERIFLAYER	0x08000000	// Draw LayerBorder when layered

// Positions for tools (CM_TOOLPOS)
#define CTP_TOP				0x0000
#define CTP_LEFT			0x0001
#define CTP_BOTTOM			0x0002
#define CTP_RIGHT			0x0003
#define CTP_FIXED			0x0004
#define CTP_FLOAT			0x7FFF
#define CTP_SWITCH			0x7FFE

// Tools Options
// Legend Options
#define CHART_LWORDBREAK		0x00000001
#define CHART_LSKIPEMPTY		0x00000002
#define CHART_LSHOWMENU			0x00000004
#define CHART_LOPTIONSDLG		0x00000008

// Menu And ToolBar IDS
#define CFX_ID_FIRST            0x7300
#define CFX_ID_CLOSE			0x7301
#define CFX_ID_EXPORTDATA		0x7302
#define CFX_ID_EXPORTBITMAP		0x7303
#define CFX_ID_LEGEND			0x7304
#define CFX_ID_SERIESLEGEND		0x7305
#define CFX_ID_TOOLBAR			0x7306
#define CFX_ID_PALETTE			0x7307
#define CFX_ID_PATTERN			0x7308
#define CFX_ID_STATUS			0x7309
#define CFX_ID_DATAEDITOR		0x730A
#define CFX_ID_3D				0x730B
#define CFX_ID_CLUSTER			0x730C
#define CFX_ID_HORZGRID			0x730D
#define CFX_ID_VERTGRID			0x730E
#define CFX_ID_ZOOM				0x730F
#define CFX_ID_GALLERY          0x7310
#define CFX_ID_COLOR			0x7311
#define CFX_ID_TOOLS			0x7312
#define CFX_ID_PRINT			0x7313
#define CFX_ID_HELPCONTENTS		0x7314
#define CFX_ID_HELPHOWTOUSE		0x7315
#define CFX_ID_EXPORTMETAFILE	0x7316

// Gallery types	
#define CFX_ID_LINE				0x7350
#define CFX_ID_BAR				0x7351
#define CFX_ID_SPLINE			0x7352
#define CFX_ID_MARK				0x7353
#define CFX_ID_PIE				0x7354
#define CFX_ID_AREA				0x7355
#define CFX_ID_PARETO			0x7356
#define CFX_ID_SCATTER			0x7357
#define CFX_ID_HILOW			0x7358
#define CFX_ID_SURFACE			0x7359
#define CFX_ID_POLAR			0x735A
#define CFX_ID_CUBE				0x735B
#define CFX_ID_DOUGHNUT			0x735C
#define CFX_ID_HORZBAR			0x735D
	
#define CFX_ID_DLGFIRST			0x7400
#define CFX_ID_DLGLAST			0x74FF

#define CFX_ID_ROTATE			0x7400
#define CFX_ID_OPTIONS			0x7401
#define CFX_ID_EDITTITLES		0x7402
#define CFX_ID_PAGESETUP		0x7403
#define CFX_ID_DLGPRINT			0x7404
#define CFX_ID_EXPORTFILE		0x7405
#define CFX_ID_IMPORTFILE		0x7406
#define CFX_ID_EXPORTTEMPLATE	0x7407
#define CFX_ID_IMPORTTEMPLATE  	0x7408
#define CFX_ID_ABOUT			0x7409
#define CFX_ID_GENERAL          0x740A
#define CFX_ID_SERIES           0x740B
#define CFX_ID_SCALE			0x740C
#define CFX_ID_FONTS			0x740D
#define CFX_ID_FONTLT			0x740E
#define CFX_ID_FONTRT			0x740F
#define CFX_ID_FONTTT			0x7410
#define CFX_ID_FONTBT			0x7411
#define CFX_ID_FONTXL			0x7412
#define CFX_ID_FONTYL			0x7413
#define CFX_ID_FONTFX			0x7414
#define CFX_ID_FONTLY			0x7415
#define CFX_ID_FONTVAL          0x7416

#define CFX_ID_LAST				0x74FF

// Reserved IDS
#define CFX_ID_RESERVEDFIRST	0x7500
#define CFX_ID_RESERVEDLAST		0x76FF

typedef CHART_STITEM far *CHART_STITEMP;

// CM_SHOWDIALOG Constants
#define CDIALOG_EXPORTFILE		CFX_ID_EXPORTFILE
#define CDIALOG_IMPORTFILE		CFX_ID_IMPORTFILE
#define CDIALOG_WRITETEMPLATE	CFX_ID_EXPORTTEMPLATE
#define CDIALOG_READTEMPLATE    CFX_ID_IMPORTTEMPLATE
#define CDIALOG_PAGESETUP		CFX_ID_PAGESETUP
#define CDIALOG_ABOUT			CFX_ID_ABOUT
#define CDIALOG_OPTIONS			CFX_ID_OPTIONS
#define CDIALOG_EDITTITLES		CFX_ID_EDITTITLES
#define CDIALOG_FONTS			CFX_ID_FONTS
#define CDIALOG_ROTATE			CFX_ID_ROTATE
#define CDIALOG_GENERAL			CFX_ID_GENERAL
#define CDIALOG_SERIES			CFX_ID_SERIES
#define CDIALOG_SCALE			CFX_ID_SCALE

// CM_GETPAINTINFO Constants
enum { CPI_GETDC, CPI_RELEASEDC, CPI_PIXELTOMARKER, CPI_MARKERTOPIXEL, CPI_VALUETOPIXEL, 
	   CPI_PIXELTOVALUE, CPI_POSITION, CPI_DIMENTIONS, CPI_PRINTINFO, CPI_SCROLLINFO, CPI_3DINFO, CPI_3DTO2D};

// StatusBar Item Styles
#define CHART_STLEFT		0x0000
#define CHART_STCENTER		0x0001
#define CHART_STRIGHT		0x0002

// Styles for DataStyle (for VB 3.0 only)
#define CHART_DS_SERLEGEND		0x00000001L
#define CHART_DS_USETEXTASLEG	0x00000002L
#define CHART_DS_USEDATEASLEG	0x00000004L

// Types DataType Property in VB 3.0
#define CDT_STRING		0x0001
#define CDT_NUMBER		0x0007
#define CDT_NOTUSED		0xFFFF

#define CHART_MAXBOUNDFIELDS	16

#define CHART_E					2.71828182846

#define __CHARTFX20__
#endif

// VBX Defines

#ifndef __CHARTFX20VBXPARAMS__

// Definitions Needed to parse event params
#define AFX_NUM_EVENTPARAM(type, lpParams)	(type FAR&)(**(type FAR* FAR*)lpParams)
#define AFX_HLSTR_EVENTPARAM(lpParams)	(HLSTR FAR&)(*(HLSTR FAR*)lpParams)
#define AFX_NUM_EVENTPARAMINDEX(type, lpParams, index) (type FAR&)(**((type FAR* FAR*)(lpParams) + index))
#define AFX_HLSTR_EVENTPARAMINDEX(lpParams, index) (HLSTR FAR&)(*((HLSTR FAR*)(lpParams) + index))

// CN_LBUTTONDBLCLK , CN_RBUTTONDOWN
// XPOS, YPOS, POINT, SERIES, RESERVED
#define CNP_YPOS(l)		AFX_NUM_EVENTPARAMINDEX(int,l,3)
#define CNP_XPOS(l)		AFX_NUM_EVENTPARAMINDEX(int,l,4)

// CN_CHANGEVALUE
// VALUE, POINT, SERIES, RESERVED
#define CNP_VALUE(l)	AFX_NUM_EVENTPARAMINDEX(double,l,3)

// CN_CHANGESTRING, CN_CHANGECOLOR, CN_CHANGEPATTERN
// INDEX, TYPE , RESERVED

// CN_CHANGEPALETTE, CN_CHANGEFONT, CN_CHANGEPATTPAL
// INDEX

// CN_MENU
// PARAM,POINT,SERIES,RESERVED
#define CNP_PARAM(l)	AFX_NUM_EVENTPARAMINDEX(int,l,3)

// CN_CHANGETYPE
// NEWTYPE, RESERVED
#define CNP_NEWTYPE(l)	AFX_NUM_EVENTPARAMINDEX(int,l,1)

// CN_SCROLL
// SCROLLMSG, SCROLLPARAM, RESERVED
#define CNP_SCROLLPARAM(l)	AFX_NUM_EVENTPARAMINDEX(int,l,1)
#define CNP_SCROLLMSG(l)	AFX_NUM_EVENTPARAMINDEX(int,l,2)

// CN_GETLEGEND
// INDEX, RESERVED

// CN_INTERNALCOMMAND, CN_USERCOMMAND
// WPARAM, LPARAM, RESERVED
#define CNP_LPARAM(l)		AFX_NUM_EVENTPARAMINDEX(long,l,1)
#define CNP_WPARAM(l)		AFX_NUM_EVENTPARAMINDEX(int,l,2)

// CN_SHOWTOOLBAR
// INDEX, RESERVED

// CN_PREPAINT, CN_POSTPAINT
// WPAINT, HPAINT, LPAINT, RESERVED
#define CNP_LPAINT(l)		AFX_NUM_EVENTPARAMINDEX(long,l,1)
#define CNP_HPAINT(l)		AFX_NUM_EVENTPARAMINDEX(int,l,2)
#define CNP_WPAINT(l)		AFX_NUM_EVENTPARAMINDEX(int,l,3)

// CN_PAINTMARKER
// XMARKER, YMARKER, LPAINTMARKER, SERIES, POINT, RESERVED
#define CNP_LPAINTMARKER(l)		AFX_NUM_EVENTPARAMINDEX(long,l,3)
#define CNP_YMARKER(l)			AFX_NUM_EVENTPARAMINDEX(int,l,4)
#define CNP_XMARKER(l)			AFX_NUM_EVENTPARAMINDEX(int,l,5)

// CN_LBUTTONDOWN, CN_LBUTTONUP, CN_RBUTTONUP, CN_RBUTTONDBLCLK, CN_MOUSEMOVE
// XMOUSE, YMOUSE, RESERVED
#define CNP_YMOUSE(l)		AFX_NUM_EVENTPARAMINDEX(int,l,1)
#define CNP_XMOUSE(l)		AFX_NUM_EVENTPARAMINDEX(int,l,2)

// Various Events
#define CNP_RESERVED(l)	AFX_NUM_EVENTPARAMINDEX(int,l,0)
#define CNP_POINT(l)	AFX_NUM_EVENTPARAMINDEX(int,l,1)
#define CNP_SERIE(l)	AFX_NUM_EVENTPARAMINDEX(int,l,2)
#define CNP_SERIES(l)	AFX_NUM_EVENTPARAMINDEX(int,l,2)
#define CNP_INDEX(l)	AFX_NUM_EVENTPARAMINDEX(int,l,1)
#define CNP_TYPE(l)		AFX_NUM_EVENTPARAMINDEX(int,l,2)

// Return Value
#define CNP_RETURNVALUE(lp,i)	(**(int FAR* FAR *) lp) = (int) (i)

#define __CHARTFX20VBXPARAMS__
#endif

#ifndef __CHARTFX20VBXPROP__

// PROPERTIES
#define CP_CTLNAME			0
#define CP_INDEX			1
#define CP_LEFT				2
#define CP_TOP				3
#define CP_WIDTH			4
#define CP_HEIGHT			5
#define CP_VISIBLE			6
#define CP_PARENT			7
#define CP_HWND				8
#define CP_BORDERSTYLEOFF	9
#define CP_ABOUT			10
#define CP_TYPE				11
#define CP_STYLE			12
#define CP_NSERIES          13
#define CP_NVALUES          14
#define CP_OPENDATA			15
#define CP_CLOSEDATA		16
#define CP_VALUE			17
#define CP_XVALUE			18
#define CP_INIVALUE			19
#define CP_CONST			20
#define CP_THISCOLOR		21
#define CP_COLOR			22
#define CP_THISBKCOLOR		23
#define CP_BKCOLOR			24
#define CP_ADM_DLG          25
#define CP_ADM				26
#define CP_LGAP				27
#define CP_RGAP				28
#define CP_TGAP				29
#define CP_BGAP				30
#define CP_DECIMALS			31
#define CP_POINTTYPE		32
#define CP_SCHEME			33
#define CP_STACKED			34
#define CP_GRID				35
#define CP_WALLWIDTH		36
#define CP_PATTERN			37
#define CP_BARHORZGAP		38
#define CP_VIEWROT3D		39
#define CP_VIEW3D			40
#define CP_ANGLES3D			41
#define CP_PIXFACTOR		42
#define CP_LINEWIDTH		43
#define CP_LINESTYLE		44
#define CP_LINECOLOR		45
#define CP_LINEBKCOLOR		46
#define CP_FIXEDWIDTH		47
#define CP_FIXEDSTYLE		48
#define CP_FIXEDCOLOR		49
#define CP_FIXEDBKCOLOR		50
#define CP_FIXEDGAP			51
#define CP_DBLCLK_DLG		52
#define CP_DBLCLK           53
#define CP_RIGCLK_DLG		54
#define CP_RIGCLK           55
#define CP_RGBBARHORZ		56
#define CP_RGBBK			57
#define CP_RGB2DBK			58
#define CP_RGB3DBK			59
#define CP_FONT_DLG         60
#define CP_FONT				61
#define CP_TITLE_DLG        62
#define CP_TITLE			63
#define CP_STATUS			64
#define CP_SHOWSTATUS		65
#define CP_LANGUAGE			66
#define CP_HTEXT			67
#define CP_LEGEND			68
#define CP_SERLEG			69
#define CP_KEYLEG			70
#define CP_FIXLEG			71
#define CP_YLEG				72
#define CP_KEYSER			73
#define CP_STATUSTEXT		74
#define CP_EXPORTFILE		75
#define CP_IMPORTFILE		76
#define CP_WRITETEMPLATE	77
#define CP_READTEMPLATE		78
#define CP_CHARTSTATUS		79
#define CP_RGBFONT			80
#define CP_EDIT				81
#define CP_COPYDATA			82
#define CP_COPYBITMAP		83
#define CP_PRINT			84
#define CP_HFONT			85
#define CP_THISSERIE		86
#define CP_CHARTTYPE		87
#define CP_CHART3D			88
#define CP_TOOLBAR			89
#define CP_PALETTEBAR		90
#define CP_PATTERNBAR		91
#define CP_THISPOINT		92
#define CP_CUSTTOOL			93
#define CP_HCTLWND			94
#define CP_RETURNVALUE		95
#define CP_RESERVED1		96
#define CP_RESERVED2		97
#define CP_RESERVED3		98
#define CP_AUTOINC			99
#define CP_THISVALUE		100
#define CP_VERTGRIDGAP		101
#define CP_XLEGTYPE			102
#define CP_CONSTTYPE		103
#define CP_ITEMWIDTH		104
#define CP_ITEMSTYLE		105
#define CP_ITEMCOLOR		106
#define CP_DECIMALSNUM		107
#define CP_SHOWDIALOG		108
#define CP_TAG				109
#define CP_LEGENDWIDTH		110
#define CP_SCROLL			111
#define CP_HELPCONTEXTID	112		// for VB 3.0 Only
#define CP_BARBITMAP		113
#define CP_MARKERSIZE		114
#define CP_MARKERVOLUME		115
#define CP_DEPTH			116
#define CP_LIGHT			117
#define CP_SHAPE			118
#define CP_MULTITYPE		119
#define CP_MULTISHAPE		120
#define CP_GALLERYTOOL		121
#define CP_CLEARLEGEND		122
#define CP_MAXVALUES		123
#define CP_REALTIMESTYLE	124
#define CP_EXPORT			125
#define CP_TBBITMAP			126
#define CP_TBITEMID			127
#define CP_TBITEMSTYLE		128
#define CP_ENABLETBITEM		129
#define CP_MULTIYAXIS		130
#define CP_TOOLSTYLE		131
#define CP_ZOOM				132
#define CP_ITEMBKCOLOR		133
#define CP_IMPORT			134
#define CP_SEPARATESLICE	135
#define CP_PAINTINFO		136
#define CP_OPTIONS_DLG		137
#define CP_TOOLSIZE			138
#define CP_EXPORTSTR		139
#define CP_IMPORTSTR		140
#define CP_DATASOURCE		141		// for VB 3.0 Only
#define CP_DATATYPE			142		// for VB 3.0 Only
#define CP_DATASTYLE		143		// for VB 3.0 Only
#define CP_RESERVED4		144
#define CP_TOOLPOS			145
#define CP_TYPEEX			146
#define CP_STYLEEX			147
#define CP_MOUSECAPTURE		148
#define CP_LEGSTYLE			149
#define CP_MULTILINESTYLE	150
#define CP_CURRENTAXIS		151
#define CP_ENABLED			152
#define CP_CUSTOMTOOL		153
#define CP_MULTIPOINT		154

#define __CHARTFX20VBXPROP__
#endif

#ifdef __cplusplus 
} 
#endif 
